/*===================================//
 *
 * fm.h
 *
 * fm.cpp
 *
 * written by JS. Park.
 *
 *===================================*/
#ifndef __FM_H__
#define __FM_H__

#include "acha.h"
#include "fm.h"

class FileManager
{
	private :
		bool is_run;

		vector<scanInfo> 	lastList;
		vector<scanInfo>	scanList;

		//DIR *dpScan;
		struct stat fs;
		struct dirent *dp;
		scanInfo element;

	public :		
		FileManager();		
		~FileManager();

		bool debugMode;
		bool lockState;
	
		vector<changeInfo>	changeList;

		void run(void);
		void stop(void);
		void showList(int);

		static void* fm_thread(void*);
		int scanSubDirectory(char *, time_t*);

		int isChanged(syncListNode *);		// SM에서 호출
		void loadChangedFile(char *);
		void writeChangedFile( char * );
		void writeCFL(char * );

		void lock( void )
		{
			lockState = true;
		};

		void unlock( void )
		{
			lockState = false;
		};

};

#endif
