/*===================================//
 *
 * sm.h
 *
 * sm.cpp
 *
 * written by korzero.
 *
 * modified by fantasia.
 *
 *===================================*/
#ifndef __SYNCMANAGER_H__
#define __SYNCMANAGER_H__

#include "acha.h"

class SyncManager
{
	private :

		syncListNode slnTmp;		// SyncListNode Tmp

		FILE *fpSyncList;			// SyncList File Pointer
		char *pathSyncList;

		char *cmd[10];
		int countOfCmd;

		char linebuf[DATASIZ];		// line buffer

	public :
		SyncManager()
		{
			lockState = false;
		};
		~SyncManager() {};

		deque<syncListNode> 		syncList;

		bool lockState;				// lock
		bool debugMode;

		void test(void);			// Test 용

		void loadSyncList( void );	// SyncList(File)를 로드하는 함수 
		void cleanSyncList( void ); // syncList를 초기화 하는 함수
		void cleanSyncListNode(syncListNode ); // syncListNode한개의 메모리 해제
		void writeSyncList( void ); // syncList(Memory)를 파일로 쓰는 함수

		int syncExist( char *name ); // 해당 이름이 존재하는지 확인

		void setFlag( char *, int );	// 해당 flag를 on/off하는 함수
		bool isFlag(char *, int );		// 해당 flag가 set 되어 있는지 확인하는 함수
		void updateFileSize(char *, int);
		void updateOption(char *, int);

		int cmdParsing( char * );
		void clearCmd( char ** );
		int executeCommand( char ** );


		void setLineBuf( char * );

		int addSync( void );		
		
		// 새로운 sync를 생성하는 함수
		int addSync( char*, char*, char*, char* , char *, char *, int, int);

		int delSyncNode ( char * );
		int delSyncNodeFromRemote ( char * );

		int addSyncFromRemote( char *, char * );
		char *getTargetbyName( char * );
		void updateSyncTime( char * , time_t );
		void updateFlag( char *, int );

		int delSync( int );

		void clean_slnTmp( void );

		static void *run( void * );
		int syncProc( void *, int );

		void debug( void );
		void showList( void );

		void lock( void )
		{
			lockState = true;
		};

		void unlock( void )
		{
			lockState = false;
		};
};

#endif
